
(* Simple formula (C) Sidyganov 1993 *)

IMPLEMENTATION MODULE Kern;
IMPORT IO,MATHLIB,MuvMul,Menus,Str,WindowS;
FROM MuvMul IMPORT Aty,Bty,Cty,Dty,XYty,Ka,Kb,Kc,Kd,Mode;

VAR   SumFyxx : TyStolbYXX;
      SumFyx : TyStolbYX;
      SumFy  : TyStolbY;

VAR  ErrorSignal : BOOLEAN;
     old         : LONGREAL;
PROCEDURE NilBasis(x:LONGREAL):LONGREAL;
BEGIN  ErrorSignal := TRUE; RETURN 1.
END NilBasis;


PROCEDURE A1b(x:LONGREAL):LONGREAL;
BEGIN  old:=x;  ErrorSignal := FALSE; RETURN 1.
END A1b;
CONST A1=Fbasis(A1b,NilBasis,NilBasis,7,'','','','Error','Error','Error');

PROCEDURE Ab(x:LONGREAL):LONGREAL;
BEGIN old:=x;
      IF (1.E-30 < ABS(x))AND(ABS(x) < 1.E30) THEN
                                  ErrorSignal := FALSE; RETURN x
      ELSE IF ABS(x)<=1.E-30 THEN ErrorSignal := FALSE; RETURN 0.
           ELSE                   ErrorSignal := TRUE;  RETURN 0.
           END
      END;
END Ab;

CONST A=Fbasis(Ab,Ab,A1b,15,' ','x','','y',' =','');
(*PROCEDURE ANb(x:LONGREAL):LONGREAL;
BEGIN RETURN -1.*A(x)
END ANb;*)

PROCEDURE Bb(x:LONGREAL):LONGREAL;
BEGIN ErrorSignal := FALSE; old:=x;
      IF 1.E30 < ABS(x) THEN       RETURN  0.
      ELSE IF 1.E-30 < ABS(x) THEN RETURN  1./x
           ELSE IF old>=0.    THEN RETURN  1.E27
                ELSE               RETURN -1.E27
                END
           END
      END;
END Bb;

PROCEDURE Qb(x:LONGREAL):LONGREAL;
BEGIN
      ErrorSignal := FALSE;
      IF (1.E-15>ABS(x)) THEN RETURN 1.E-30
      ELSE
       IF (1.E15<ABS(x)) THEN RETURN 1.E30
       ELSE                   RETURN x*x
       END
     END
END Qb;

PROCEDURE QNb(x:LONGREAL):LONGREAL;
BEGIN  RETURN -1.*Qb(x)
END QNb;

CONST B=Fbasis(Bb,Bb,QNb,12,'/','x','','y','=1/(',')');

PROCEDURE Logb(x:LONGREAL):LONGREAL;
BEGIN IF 0.<x THEN ErrorSignal := FALSE; RETURN MATHLIB.Log(x)
      ELSE         ErrorSignal := TRUE;  RETURN -1.E30   END
END Logb;

PROCEDURE Expb(x:LONGREAL):LONGREAL;
BEGIN IF (-50.<x) AND (x<50.) THEN ErrorSignal := FALSE;
            RETURN MATHLIB.Exp(x)
      ELSE  IF x<-50. THEN ErrorSignal := FALSE; RETURN 0.
            ELSE           ErrorSignal := TRUE;  RETURN 1.
            END
      END
END Expb;

CONST Log=Fbasis(Logb,Expb,Ab,14,' Ln(','x',')','y','=exp(',')');

PROCEDURE ExpNb(x:LONGREAL):LONGREAL;
BEGIN RETURN Expb(-x)
END ExpNb;

CONST Exp=Fbasis(Expb,Logb,ExpNb,11,' exp(','x',')','y','=Ln(',')');
CONST ExpN=Fbasis(ExpNb,NilBasis,NilBasis,10,'/exp(','x',')','Error','Error','Error');

PROCEDURE Sqrtb(x:LONGREAL):LONGREAL;
BEGIN IF (1.E-100<x)AND(x<1.E100) THEN ErrorSignal := FALSE;
                     RETURN MATHLIB.Sqrt(x)
      ELSE IF (-1.E-100<x)AND(x<1.E-100) THEN ErrorSignal := FALSE;
                                         RETURN 0.
           ELSE ErrorSignal := TRUE; RETURN 0.
           END
      END
END Sqrtb;

PROCEDURE B2b(x:LONGREAL):LONGREAL;
BEGIN RETURN Bb(x)/2.
END B2b;

CONST Q=Fbasis(Qb,Sqrtb,B2b,13,' (','x',')**2','y','=Sqrt(',')');

PROCEDURE Q3b(x:LONGREAL):LONGREAL;
BEGIN
      ErrorSignal := FALSE;
      IF (1.E-10>ABS(x)) THEN RETURN 1.E-30
      ELSE
       IF (1.E10<ABS(x)) THEN RETURN 1.E30
       ELSE                   RETURN x*x*x
       END
     END
END Q3b;
CONST Q3=Fbasis(Q3b,NilBasis,NilBasis,3,' (','x',')**3','Error','Error','Error');

PROCEDURE Q4b(x:LONGREAL):LONGREAL;
BEGIN
      ErrorSignal := FALSE;
      IF (1.E-8>ABS(x)) THEN RETURN 1.E-30
      ELSE
       IF (1.E8<ABS(x)) THEN RETURN 1.E30
       ELSE                   RETURN x*x*x*x
       END
     END
END Q4b;
CONST Q4=Fbasis(Q4b,NilBasis,NilBasis,4,' (','x',')**4','Error','Error','Error');

PROCEDURE Q5b(x:LONGREAL):LONGREAL;
BEGIN
      ErrorSignal := FALSE;
      IF (1.E-6>ABS(x)) THEN RETURN 1.E-30
      ELSE
       IF (1.E6<ABS(x)) THEN RETURN 1.E30
       ELSE                   RETURN x*x*x*x*x
       END
     END
END Q5b;
CONST Q5=Fbasis(Q5b,NilBasis,NilBasis,5,' (','x',')**5','Error','Error','Error');

PROCEDURE Q6b(x:LONGREAL):LONGREAL;
BEGIN
      ErrorSignal := FALSE;
      IF (1.E-5>ABS(x)) THEN RETURN 1.E-30
      ELSE
       IF (1.E5<ABS(x)) THEN RETURN 1.E30
       ELSE                   RETURN x*x*x*x*x*x
       END
     END
END Q6b;
CONST Q6=Fbasis(Q6b,NilBasis,NilBasis,6,' (','x',')**6','Error','Error','Error');

PROCEDURE T0b(x:LONGREAL):LONGREAL;
BEGIN  RETURN A1b(x)
END T0b;
CONST T0=Fbasis(T0b,NilBasis,NilBasis,7,' T0(','x',')','Error','Error','Error');

PROCEDURE T1b(x:LONGREAL):LONGREAL;
BEGIN  RETURN Ab(x)
END T1b;
CONST T1=Fbasis(T1b,NilBasis,NilBasis,15,' T1(','x',')','Error','Error','Error');

PROCEDURE T2b(x:LONGREAL):LONGREAL;
VAR a:LONGREAL;
BEGIN a:=2.*Qb(x)-1.; RETURN a
END T2b;
CONST T2=Fbasis(T2b,NilBasis,NilBasis,13,' T2(','x',')','Error','Error','Error');

PROCEDURE T3b(x:LONGREAL):LONGREAL;
VAR a:LONGREAL;
BEGIN a:=4.*Q3b(x)-3.*Ab(x); RETURN a
END T3b;
CONST T3=Fbasis(T3b,NilBasis,NilBasis,3,' T3(','x',')','Error','Error','Error');

PROCEDURE T4b(x:LONGREAL):LONGREAL;
VAR a:LONGREAL;
BEGIN a:=8.*Q4b(x)+8.*Qb(x)+1.; RETURN a
END T4b;
CONST T4=Fbasis(T4b,NilBasis,NilBasis,4,' T4(','x',')','Error','Error','Error');

PROCEDURE T5b(x:LONGREAL):LONGREAL;
VAR a:LONGREAL;
BEGIN a:=16.*Q5b(x)-20.*Q3b(x)+5.*Ab(x); RETURN a
END T5b;
CONST T5=Fbasis(T5b,NilBasis,NilBasis,5,' T5(','x',')','Error','Error','Error');

PROCEDURE T6b(x:LONGREAL):LONGREAL;
VAR a:LONGREAL;
BEGIN a:=32.*Q6b(x)-48.*Q4b(x)+18.*Qb(x)-1.; RETURN a
END T6b;
CONST T6=Fbasis(T6b,NilBasis,NilBasis,6,' T6(','x',')','Error','Error','Error');

PROCEDURE Sinb(x:LONGREAL):LONGREAL;
BEGIN ErrorSignal := FALSE;
      IF (1.E-30>ABS(x)) THEN RETURN 1.E-30
      ELSE                    RETURN MATHLIB.Sin(x)
      END
END Sinb;
CONST Sin=Fbasis(Sinb,NilBasis,NilBasis,15,' Sin(','x',')','Error','Error','Error');

PROCEDURE Sin2b(x:LONGREAL):LONGREAL;
BEGIN ErrorSignal := FALSE;
      IF (1.E-30>ABS(x)) THEN RETURN 1.E-30
      ELSE                    RETURN MATHLIB.Sin(2.*x)
      END
END Sin2b;
CONST Sin2=Fbasis(Sin2b,NilBasis,NilBasis,13,' Sin2(','x',')','Error','Error','Error');

PROCEDURE Sin3b(x:LONGREAL):LONGREAL;
BEGIN ErrorSignal := FALSE;
      IF (1.E-30>ABS(x)) THEN RETURN 1.E-30
      ELSE                    RETURN MATHLIB.Sin(3.*x)
      END
END Sin3b;
CONST Sin3=Fbasis(Sin3b,NilBasis,NilBasis,3,' Sin3(','x',')','Error','Error','Error');

PROCEDURE Sin4b(x:LONGREAL):LONGREAL;
BEGIN ErrorSignal := FALSE;
      IF (1.E-30>ABS(x)) THEN RETURN 1.E-30
      ELSE                    RETURN MATHLIB.Sin(4.*x)
      END
END Sin4b;
CONST Sin4=Fbasis(Sin4b,NilBasis,NilBasis,4,' Sin4(','x',')','Error','Error','Error');

PROCEDURE Sin5b(x:LONGREAL):LONGREAL;
BEGIN ErrorSignal := FALSE;
      IF (1.E-30>ABS(x)) THEN RETURN 1.E-30
      ELSE                    RETURN MATHLIB.Sin(5.*x)
      END
END Sin5b;
CONST Sin5=Fbasis(Sin5b,NilBasis,NilBasis,5,' Sin5(','x',')','Error','Error','Error');

PROCEDURE Sin6b(x:LONGREAL):LONGREAL;
BEGIN ErrorSignal := FALSE;
      IF (1.E-30>ABS(x)) THEN RETURN 1.E-30
      ELSE                    RETURN MATHLIB.Sin(6.*x)
      END
END Sin6b;
CONST Sin6=Fbasis(Sin6b,NilBasis,NilBasis,6,' Sin6(','x',')','Error','Error','Error');

PROCEDURE Sin7b(x:LONGREAL):LONGREAL;
BEGIN ErrorSignal := FALSE;
      IF (1.E-30>ABS(x)) THEN RETURN 1.E-30
      ELSE                    RETURN MATHLIB.Sin(7.*x)
      END
END Sin7b;
CONST Sin7=Fbasis(Sin7b,NilBasis,NilBasis,0,' Sin7(','x',')','Error','Error','Error');

PROCEDURE Cosb(x:LONGREAL):LONGREAL;
BEGIN ErrorSignal := FALSE; RETURN MATHLIB.Cos(x)
END Cosb;
CONST Cos=Fbasis(Cosb,NilBasis,NilBasis,15,' Cos(','x',')','Error','Error','Error');

PROCEDURE Cos2b(x:LONGREAL):LONGREAL;
BEGIN ErrorSignal := FALSE; RETURN MATHLIB.Cos(2.*x)
END Cos2b;
CONST Cos2=Fbasis(Cos2b,NilBasis,NilBasis,13,' Cos2(','x',')','Error','Error','Error');

PROCEDURE Cos3b(x:LONGREAL):LONGREAL;
BEGIN ErrorSignal := FALSE; RETURN MATHLIB.Cos(3.*x)
END Cos3b;
CONST Cos3=Fbasis(Cos3b,NilBasis,NilBasis,3,' Cos3(','x',')','Error','Error','Error');

PROCEDURE Cos4b(x:LONGREAL):LONGREAL;
BEGIN ErrorSignal := FALSE; RETURN MATHLIB.Cos(4.*x)
END Cos4b;
CONST Cos4=Fbasis(Cos4b,NilBasis,NilBasis,4,' Cos4(','x',')','Error','Error','Error');

PROCEDURE Cos5b(x:LONGREAL):LONGREAL;
BEGIN ErrorSignal := FALSE; RETURN MATHLIB.Cos(5.*x)
END Cos5b;
CONST Cos5=Fbasis(Cos5b,NilBasis,NilBasis,5,' Cos5(','x',')','Error','Error','Error');

PROCEDURE Cos6b(x:LONGREAL):LONGREAL;
BEGIN ErrorSignal := FALSE; RETURN MATHLIB.Cos(6.*x)
END Cos6b;
CONST Cos6=Fbasis(Cos6b,NilBasis,NilBasis,6,' Cos6(','x',')','Error','Error','Error');

VAR  RRc, RRmax, RRmin : TyStolbX;
     RRbNum            : TypFx;
PROCEDURE RRb(x:LONGREAL):LONGREAL;
BEGIN
 IF x>RRmin[RRbNum] THEN ErrorSignal := FALSE;
       IF (RRmax[RRbNum]<x)   THEN RETURN 1.E30
       ELSE                   RETURN MATHLIB.Pow(x,RRc[RRbNum])
       END
  ELSE
       IF x>0. THEN ErrorSignal := FALSE;
                     RETURN 0.
       ELSE          ErrorSignal := TRUE;
                     RETURN 0.
       END
  END
END RRb;

PROCEDURE RRb1(x:LONGREAL):LONGREAL;
BEGIN RRbNum:=1;
      RETURN RRb(x)
END RRb1;

PROCEDURE RRb2(x:LONGREAL):LONGREAL;
BEGIN RRbNum:=2;
      RETURN RRb(x)
END RRb2;

PROCEDURE RRb3(x:LONGREAL):LONGREAL;
BEGIN RRbNum:=3;
      RETURN RRb(x)
END RRb3;

PROCEDURE RRb4(x:LONGREAL):LONGREAL;
BEGIN RRbNum:=4;
      RETURN RRb(x)
END RRb4;

PROCEDURE RRb5(x:LONGREAL):LONGREAL;
BEGIN RRbNum:=5;
      RETURN RRb(x)
END RRb5;

PROCEDURE RRb6(x:LONGREAL):LONGREAL;
BEGIN RRbNum:=6;
      RETURN RRb(x)
END RRb6;

PROCEDURE RRb7(x:LONGREAL):LONGREAL;
BEGIN RRbNum:=7;
      RETURN RRb(x)
END RRb7;

VAR  RMc, RMmax, RMmin : TyStolbX;
     RMbNum            : TypFx;
PROCEDURE RMb(x:LONGREAL):LONGREAL;
BEGIN
    ErrorSignal := FALSE;
    IF (ABS(x)< RMmin[RMbNum]) THEN  RETURN 1.
    ELSE
       IF (ABS(x)<RMmax[RMbNum]) THEN RETURN MATHLIB.Pow(RMc[RMbNum],x)
       ELSE IF x<0. THEN RETURN 0.
            ELSE RETURN 1.E30
            END
       END
    END
END RMb;

PROCEDURE RMb1(x:LONGREAL):LONGREAL;
BEGIN RMbNum:=1;
      RETURN RMb(x)
END RMb1;

PROCEDURE RMb2(x:LONGREAL):LONGREAL;
BEGIN RMbNum:=2;
      RETURN RMb(x)
END RMb2;

PROCEDURE RMb3(x:LONGREAL):LONGREAL;
BEGIN RMbNum:=3;
      RETURN RMb(x)
END RMb3;

PROCEDURE RMb4(x:LONGREAL):LONGREAL;
BEGIN RMbNum:=4;
      RETURN RMb(x)
END RMb4;

PROCEDURE RMb5(x:LONGREAL):LONGREAL;
BEGIN RMbNum:=5;
      RETURN RMb(x)
END RMb5;

PROCEDURE RMb6(x:LONGREAL):LONGREAL;
BEGIN RMbNum:=6;
      RETURN RMb(x)
END RMb6;

PROCEDURE RMb7(x:LONGREAL):LONGREAL;
BEGIN RMbNum:=7;
      RETURN RMb(x)
END RMb7;

CONST FyCns     = TyFuY( A,  B,   Log, Exp, Q);
      FxAss     = TyFuX( A1, A,   B,   Log, Exp, Q,   ExpN);
      FxPol     = TyFuX( A1, A,   Q,   Q3,  Q4,  Q5,  Q6);
      FxFur     = TyFuX( A1, Sin, Cos, Sin2,Cos2,Sin3,Cos3);
      FxFurSin  = TyFuX( Sin,Sin2,Sin3,Sin4,Sin5,Sin6,Sin7);
      FxFurCos  = TyFuX( A1, Cos, Cos2,Cos3,Cos4,Cos5,Cos6);
      FxCheb    = TyFuX( T0, T1,  T2,  T3,  T4,  T5,  T6);

VAR Ftmp : TyFuX;
PROCEDURE InfoBasis;
VAR  ky,kyMax1   : INTEGER;
     R    :  ARRAY [0..30] OF CHAR;
BEGIN
 IF MaxFuNumXv > 2 THEN kyMax1:=2 ELSE kyMax1:=MaxFuNumXv END;
 WindowS.SetTitle(Menus.Anounse,' ࠧ  X',WindowS.CenterUpperTitle);
 R[0]:=' '; R[1]:=0C;
 FOR ky:=1 TO kyMax1 DO
     Str.Concat(R,R,Kern.Fx[ky].Tx1);
     IF Kern.Fx[ky].Bs#Kern.A1b THEN
          Str.Concat(R,R,MuvMul.WrFx);    Str.Concat(R,R,Kern.Fx[ky].Tx3);
     ELSE Str.Concat(R,R,' 1');
     END;
     Str.Concat(R,R,', ');
 END;
 Menus.WrStrAnounse( FALSE,R);

 IF MaxFuNumXv > 2 THEN
      IF MaxFuNumXv > 4 THEN kyMax1:=4 ELSE kyMax1:=MaxFuNumXv END;
      R[0]:=' '; R[1]:=0C;
      FOR ky:=3 TO kyMax1(*MaxFuNumXv*) DO
         Str.Concat(R,R,Kern.Fx[ky].Tx1);
         IF Kern.Fx[ky].Bs#Kern.A1b THEN
             Str.Concat(R,R,MuvMul.WrFx);    Str.Concat(R,R,Kern.Fx[ky].Tx3);
         ELSE(* graphics.outtextxy(PascalX[1,1].X,PascalX[1,1].Y-14,' 1 ');*)
             Str.Concat(R,R,' 1');
         END;
         Str.Concat(R,R,', ');
      END;
      Menus.WrStrAnounse( FALSE,R);
      IF MaxFuNumXv > 4 THEN
          R[0]:=' '; R[1]:=0C;
          FOR ky:=5 TO MaxFuNumXv DO
             Str.Concat(R,R,Kern.Fx[ky].Tx1);
             IF Kern.Fx[ky].Bs#Kern.A1b THEN
                 Str.Concat(R,R,MuvMul.WrFx);    Str.Concat(R,R,Kern.Fx[ky].Tx3);
             ELSE(* graphics.outtextxy(PascalX[1,1].X,PascalX[1,1].Y-14,' 1 ');*)
                 Str.Concat(R,R,' 1');
             END;
             Str.Concat(R,R,', ');
          END;
          Menus.WrStrAnounse( FALSE,R);
     ELSE Menus.WrStrAnounse( FALSE,'     ');
     END
 ELSE Menus.WrStrAnounse( FALSE,'     ');
 END;
 WindowS.SetTitle(Menus.Anounse,'    ',WindowS.CenterUpperTitle);
END InfoBasis;

PROCEDURE InfoBasisY;
VAR  ky,kyMax1   : INTEGER;
     R    :  ARRAY [0..30] OF CHAR;
BEGIN
 IF MaxFuNumYv > 3 THEN kyMax1:=3 ELSE kyMax1:=MaxFuNumYv END;
 Menus.WrStrAnounse( FALSE,' 㠫  ࠧ  Y:');
 R[0]:=' '; R[1]:=0C;
 FOR ky:=1 TO kyMax1 DO
     Str.Concat(R,R,MuvMul.WrFy);  Str.Concat(R,R,Kern.Fy[ky].TxRev2);
     Str.Concat(R,R,', ');
 END;
 Menus.WrStrAnounse( FALSE,R);

 IF MaxFuNumYv > 3 THEN
      R[0]:=' '; R[1]:=0C;
      FOR ky:=4 TO MaxFuNumYv DO
         Str.Concat(R,R,MuvMul.WrFy);  Str.Concat(R,R,Kern.Fy[ky].TxRev2);
         Str.Concat(R,R,', ');
      END;
      Menus.WrStrAnounse( FALSE,R);
 ELSE Menus.WrStrAnounse( FALSE,'                                ');
 END
END InfoBasisY;

PROCEDURE InfBas( B:INTEGER );
BEGIN
  Ftmp := Fx;
  IF B=1 THEN InfoBasis
  ELSE        InfoBasisY
  END;
END InfBas;

CONST RR=Fbasis(RRb1,NilBasis,NilBasis,6,' (','x',')**r1','Error','Error','Error');
      RM=Fbasis(RMb1,NilBasis,NilBasis,6,' r1**(','x',') ','Error','Error','Error');
VAR
     N1,N2           : TypFx;
     RRvar,RMvar     : TyFuX;
PROCEDURE Init;
 VAR i : TypFx;
 BEGIN N1:=1;  N2:=1;
      FOR i:=1 TO 7 DO     RRvar[i]:=RR;       RMvar[i]:=RM;
      END;
      RRvar[1].Bs:=RRb1; RRvar[2].Bs:=RRb2; RRvar[3].Bs:=RRb3;
      RRvar[4].Bs:=RRb4; RRvar[5].Bs:=RRb5; RRvar[6].Bs:=RRb6; RRvar[7].Bs:=RRb7;
      RMvar[1].Bs:=RMb1; RMvar[2].Bs:=RMb2; RMvar[3].Bs:=RMb3;
      RMvar[4].Bs:=RMb4; RMvar[5].Bs:=RMb5; RMvar[6].Bs:=RMb6; RMvar[7].Bs:=RMb7;
END Init;

PROCEDURE InitChanchNoStandard1( r :LONGREAL ):BOOLEAN;
VAR  i      : INTEGER;
     R,marc : TyText2;
     OK     : BOOLEAN;
 BEGIN
 ToRecalcMuv; MuvMul.InitBasis;
 BasisName:=Variable;
 Fy:=FyCns;
 Ftmp:=Fx;
 FOR i:=0 TO 5 DO
       Ftmp[7-i]:=Ftmp[6-i]
 END;
 Ftmp[1]:=Fx[7];

 IF r=0. THEN RRmax[N1]:=1.E100
 ELSE RRmax[N1]:=30./ABS(r);
      RRmax[N1]:=MATHLIB.Pow(10.,RRmax[N1]);
 END;
 RRmin[N1]:=1./RRmax[N1];

 R[0]:=')'; R[1]:='*';R[2]:='*';R[3]:=0C;
 Str.FixRealToStr(r,4,(*FALSE,*)marc,OK);
 IF OK THEN Str.Append(R,marc) END;
 RRvar[N1].Tx3:=R;
 RRc[N1]:=r ;
 Ftmp[1]:=RRvar[N1];

 IF N1=7 THEN N1:=1
 ELSE N1:=N1+1
 END;
 Fx:=Ftmp;
 InfoBasis;
 RETURN TRUE
END InitChanchNoStandard1;

PROCEDURE InitChanchNoStandard2( r :LONGREAL ):BOOLEAN;
VAR  i      : INTEGER;
     R,marc : TyText2;
     OK     : BOOLEAN;
 BEGIN
 ToRecalcMuv; MuvMul.InitBasis;
 BasisName:=Variable;
 Fy:=FyCns;
 Ftmp:=Fx;
 FOR i:=0 TO 5 DO
       Ftmp[7-i]:=Ftmp[6-i]
 END;
 Ftmp[1]:=Fx[7];

 r:=ABS(r);
 IF r < 1.E-100 THEN RETURN FALSE END;
 IF ABS(r-1.)<1.E-30  THEN RMmax[N2]:=10000.
 ELSE                 RMmax[N2]:=100./ABS(MATHLIB.Log10(r))
 END;
 RMmin[N2]:=-RMmax[N2];

 Str.FixRealToStr(r,4,(*FALSE,*)marc,OK);
 Str.Copy(R,' '); Str.Append(R,marc);  Str.Append(R,'**(');
 RMvar[N2].Tx1:=R;
 RMc[N2]:=r ;
 Ftmp[1]:=RMvar[N2];

 IF N2=7 THEN N2:=1
 ELSE         N2:=N2+1
 END;
 Fx:=Ftmp;
 InfoBasis;
 RETURN TRUE
END InitChanchNoStandard2;

PROCEDURE InitChanchNoStandard( r : LONGREAL; n:INTEGER):BOOLEAN;
BEGIN
 CASE n OF
  | 1 : RETURN InitChanchNoStandard1( r )
  | 2 : RETURN InitChanchNoStandard2( r )
 END
END InitChanchNoStandard;


PROCEDURE InitChanchStandard( n:INTEGER ):BOOLEAN;
VAR  i : INTEGER;
 BEGIN
 ToRecalcMuv; MuvMul.InitBasis;
 BasisName:=Variable;
 Fy:=FyCns;
 Ftmp:=Fx;
 FOR i:=0 TO 5 DO
       Ftmp[7-i]:=Ftmp[6-i]
 END;
 CASE  n OF
  | 11..17: Ftmp[1]:=FxAss[n-10]
  | 21..27: Ftmp[1]:=FxPol[n-20]
  | 31..37: Ftmp[1]:=FxFurSin[n-30]
  | 41..47: Ftmp[1]:=FxFurCos[n-40]
  | 51..57: Ftmp[1]:=FxCheb[n-50]
 END;
 Fx:=Ftmp;
 InfoBasis;
 RETURN TRUE
END InitChanchStandard;

PROCEDURE InitAssorti():BOOLEAN;
 BEGIN IF BasisName#Ass THEN
          ToRecalcMuv; MuvMul.InitBasis;
          Fx:=FxAss;   BasisName:=Ass;
          Fy:=FyCns;
          Ftmp:=Fx;    InfoBasis;
          RETURN TRUE
       ELSE RETURN FALSE
       END
END InitAssorti;

PROCEDURE InitPolynom():BOOLEAN;
 BEGIN IF BasisName#Pol THEN
          ToRecalcMuv; MuvMul.InitBasis;
          Fx:=FxPol;   BasisName:=Pol;
          Fy:=FyCns;
          Ftmp:=Fx;    InfoBasis;
          RETURN TRUE
       ELSE RETURN FALSE
       END
END InitPolynom;

PROCEDURE InitFurje():BOOLEAN;
 BEGIN IF BasisName#Fur THEN
          ToRecalcMuv; MuvMul.InitBasis;
          Fx:=FxFur;   BasisName:=Fur;
          Fy:=FyCns;
          Ftmp:=Fx;    InfoBasis;
          RETURN TRUE
       ELSE RETURN FALSE
       END
END InitFurje;

PROCEDURE InitFurjeSin():BOOLEAN;
 BEGIN IF BasisName#FurSin THEN
          ToRecalcMuv;  MuvMul.InitBasis;
          Fx:=FxFurSin; BasisName:=FurSin;
          Fy:=FyCns;
          Ftmp:=Fx;    InfoBasis;
          RETURN TRUE
       ELSE RETURN FALSE
       END
END InitFurjeSin;

PROCEDURE InitFurjeCos():BOOLEAN;
 BEGIN IF BasisName#FurCos THEN
          ToRecalcMuv;  MuvMul.InitBasis;
          Fx:=FxFurCos; BasisName:=FurCos;
          Fy:=FyCns;
          Ftmp:=Fx;    InfoBasis;
          RETURN TRUE
       ELSE RETURN FALSE
       END
END InitFurjeCos;

PROCEDURE InitCheb():BOOLEAN;
 BEGIN IF BasisName#Cheb THEN
          ToRecalcMuv; MuvMul.InitBasis;
          Fx:=FxCheb;  BasisName:=Cheb;
          Fy:=FyCns;
          Ftmp:=Fx;    InfoBasis;
          RETURN TRUE
       ELSE RETURN FALSE
       END
END InitCheb;

PROCEDURE Sum;
VAR nfX1,nfX2,nfX3 : TypFx; nfY : TypFy;
    n              : [1..MaxArray];
    Error          : BOOLEAN;
VAR a1,a2,b,db : LONGREAL;
BEGIN
  FOR nfY :=1 TO MaxFuNumYv DO       SumFy[nfY]:=0.;  ErrorFy[nfY]:=FALSE;
     FOR nfX1:=1 TO MaxFuNumXv DO    SumFyx[nfY,nfX1]:=0.;
        FOR nfX2:=1 TO MaxFuNumXv DO SumFyxx[nfY,nfX1,nfX2]:=0.;
  END END END; (* nfY ... *)

  FOR nfX1:=1 TO MaxFuNumXv DO ErrorFx[nfX1]:=FALSE END;

  MinX:=1.E10; MinY:=1.E10; MaxX:=-1.E10; MaxY:=-1.E10;
  FOR n:=1 TO MaxPointNum DO
    IF  MinY > Yold^[n] THEN MinY:=Yold^[n]; MinYx:=Xold^[n] END;
    IF  MinX > Xold^[n] THEN MinX:=Xold^[n]; MinXy:=Yold^[n] END;
    IF  Yold^[n] > MaxY THEN MaxY:=Yold^[n]; MaxYx:=Xold^[n] END;
    IF  Xold^[n] > MaxX THEN MaxX:=Xold^[n]; MaxXy:=Yold^[n] END;

    FOR nfY:=1 TO MaxFuNumYv DO IF NOT ErrorFy[nfY] THEN b:= Fy[nfY].Bs(Y^[n]);
     IF ErrorSignal THEN ErrorFy[nfY]:=TRUE  (*1*)
     ELSE db:=Fy[nfY].dB(Y^[n]);
       IF ErrorSignal THEN ErrorFy[nfY]:=TRUE  (*2*)
       ELSE b:=b*db;  SumFy[nfY]:=SumFy[nfY]  +b*b;
        FOR nfX1:=1 TO MaxFuNumXv DO IF NOT ErrorFx[nfX1] THEN
            a1:=Fx[nfX1].Bs(X^[n])*db;
            IF ErrorSignal THEN ErrorFx[nfX1]:=TRUE  (*3*)
            ELSE SumFyx[nfY,nfX1]:=SumFyx[nfY,nfX1]+a1*b;
                 FOR nfX2:=nfX1 TO MaxFuNumXv DO IF NOT ErrorFx[nfX2] THEN
                   a2:=Fx[nfX2].Bs(X^[n])*db;
                   IF ErrorSignal THEN ErrorFx[nfX2]:=TRUE  (*4*)
                   ELSE SumFyxx[nfY,nfX1,nfX2] :=SumFyxx[nfY,nfX1,nfX2]+a1*a2;
                   END (* ErSig4 *)
                 END  END (* for nfX2 *)
            END (* ErSig3 *)
        END END (* for nfX1 *)
      END (* ErSig2 *)
     END (* ErSig1 *)
    END END (* for nfY *)
   END (*n*);

    FOR nfY:=1 TO MaxFuNumYv DO
      FOR nfX1:=2 TO MaxFuNumXv DO
        FOR nfX2:=1 TO nfX1-1 DO
          SumFyxx[nfY,nfX1,nfX2] :=SumFyxx[nfY,nfX2,nfX1]
        END
      END
    END;
    ToSum:=FALSE
END Sum;

PROCEDURE  Reform(Fu:F):F;
 VAR   Test : F;
       i    : CARDINAL;
 BEGIN
   Test:=Fu;
   IF NOT Test.Co THEN
       FOR i:=1 TO Fu.Sp DO
          Test.BsX[i]:=Fx[Fu.nfX[i]];
          IF Fx[Fu.nfX[i]].Bs # A1b THEN
             Test.BsX[i].Tx2:=MuvMul.WrFx
          END
       END; (* for *)
       Test.BsY:=Fy[Fu.nfY];
       Test.BsY.TxRev1:=MuvMul.WrFy;
       Test.Mode := Mode;     Test.Co   := TRUE;
       Test.Ka   := Ka;       Test.Kb   := Kb;
       Test.Kc   := Kc;       Test.Kd   := Kd;
   END; (* if *)
   RETURN Test
END  Reform;
VAR a:TyStolbXX;    b:TyStolbX;
PROCEDURE SetUpFu(VAR Fy:F);
    VAR
        Sper          : TyStolbX;
        n,n1,n2,k,maxS: TypFx;
        Sum,Dper      : LONGREAL;
    Delta, Delta2, dY, dY2, Disp, Ytest      : LONGREAL;
    npoint                                   : [1..MaxArray];
BEGIN
  Fy.Error:=ErrorFy[Fy.nfY];
  FOR n:=1 TO Fy.Sp DO Fy.Error:=ErrorFx[Fy.nfX[n]] OR Fy.Error
  END;
  IF NOT Fy.Error THEN
   FOR n:=1 TO Fy.Sp DO  b[n]:=SumFyx[Fy.nfY,Fy.nfX[n]];
       FOR n1:=1 TO Fy.Sp DO a[n,n1]:=SumFyxx[Fy.nfY,Fy.nfX[n],Fy.nfX[n1]]
       END
   END;
   IF Fy.Sp#1 THEN (* normal MATR *)
     FOR n:=1 TO Fy.Sp-1 DO     k:=Fy.Sp-n;    maxS:=k+1;
        FOR n1:=1 TO k DO IF a[n1,k+1] > a[maxS,k+1] THEN maxS:=n1 END
        END;
        Sper:=a[k+1]; a[k+1]:=a[maxS]; a[maxS]:=Sper;
        Dper:=b[k+1]; b[k+1]:=b[maxS]; b[maxS]:=Dper;
        IF a[k+1,k+1]#0. THEN
          FOR n1:=1 TO k DO
            FOR n2:=1 TO k DO a[n1,n2]:=a[n1,n2]-a[k+1,n2]/a[k+1,k+1]*a[n1,k+1]
            END;
            b[n1]:=b[n1]-b[k+1]/a[k+1,k+1]*a[n1,k+1]
          END
        ELSE Fy.Error:=TRUE;
        END;
     END;  (* normal MATR *)
   END;
  END; (* not error *)
   IF NOT Fy.Error THEN
        Sum:=0.;
        FOR n:=1 TO Fy.Sp DO
           IF a[n,n]#0. THEN
                Fy.M[n]:=(b[n]-Sum)/a[n,n];
                Sum:=0.;
                IF n#Fy.Sp THEN
                    FOR n1:=1 TO n DO Sum:=Sum+a[n+1,n1]*Fy.M[n1] END
                END
           ELSE Fy.Error:=TRUE
           END;
        END;
        Fy.VeryBig:=FALSE;
        FOR n:=1 TO Fy.Sp DO
          IF ABS(Fy.M[n])<1.E-12 THEN Fy.M[n]:=0.; Fy.VeryBig:=TRUE END;
        END;
      (* Dispers *)
      Delta:=0.; Delta2:=0.; Disp:=0.;  npoint:=1;
      LOOP
          IF NOT Fu(Fy,Xold^[npoint],Ytest) THEN Fy.Error:=TRUE; EXIT END;

          dY:=Yold^[npoint]-Ytest; dY2:=dY*dY;
          IF dY2 > Delta2 THEN
               Delta:=dY; Delta2:=dY2; Fy.XmaxDy:=X^[npoint]
          END;
          Disp:=Disp+dY2;
          IF npoint>=MaxPointNum         THEN Fy.Error:=FALSE;   Fy.Delta2:=Disp;
                                        Fy.Delta:=Delta;   EXIT END;
          INC(npoint)
      END;
      Fy.Class:=2 * Fy.Sp;
      IF (Aty IN Mode) OR (Cty IN Mode) THEN  INC(Fy.Class) END;
      IF (Bty IN Mode) OR (Dty IN Mode) THEN  INC(Fy.Class) END;
      IF Fy.nfY=1        THEN DEC(Fy.Class) END;
      IF Fy.nfX[Fy.Sp]=1 THEN DEC(Fy.Class) END;

      IF Fy.Delta2 < Sp[Fy.Sp].Delta2 THEN
          Sp[Fy.Sp]:=Reform(Fy);
          IF Fy.Delta2 < CollectionSp[Fy.Class].Delta2 THEN
                         CollectionSp[Fy.Class]:=Sp[Fy.Sp]
          END;
      END;
      IF (Fy.Delta)*(Fy.Delta)<(Sm[Fy.Sp].Delta)*(Sm[Fy.Sp].Delta)THEN
          Sm[Fy.Sp]:=Reform(Fy);
          IF (Fy.Delta)*(Fy.Delta)<(CollectionSm[Fy.Class].Delta)
             *(CollectionSm[Fy.Class].Delta)THEN
                         CollectionSm[Fy.Class]:=Sm[Fy.Sp]
          END;
      END;
   END
END SetUpFu;

PROCEDURE SetUpFuDelt(VAR Fy:F);
    VAR
        n : TypFx;
    Delta, Delta2, dY, dY2, Disp, Ytest      : LONGREAL;
    npoint                                   : [1..MaxArray];
BEGIN
  Fy.Error:=ErrorFy[Fy.nfY];
  FOR n:=1 TO Fy.Sp DO Fy.Error:=ErrorFx[Fy.nfX[n]] OR Fy.Error
  END;
  IF NOT Fy.Error THEN
      (* Dispers *)
      Delta:=0.; Delta2:=0.; Disp:=0.;  npoint:=1;
      LOOP
          IF NOT Fu(Fy,Xold^[npoint],Ytest) THEN Fy.Error:=TRUE; EXIT END;

          dY:=Yold^[npoint]-Ytest; dY2:=dY*dY;
          IF dY2 > Delta2 THEN
               Delta:=dY; Delta2:=dY2; Fy.XmaxDy:=X^[npoint]
          END;
          Disp:=Disp+dY2;
          IF npoint>=MaxPointNum         THEN Fy.Error:=FALSE;   Fy.Delta2:=Disp;
                                        Fy.Delta:=Delta;   EXIT END;
          INC(npoint)
      END;
   END
END SetUpFuDelt;

CONST FC=F(TRUE,FALSE,1.E10,1.E10,1.,3,1,TyStolbX(0.,0.,0.,0.,0.,0.,0.),
           FALSE,TypnfX(1,1,1,1,1,1,1),1);
PROCEDURE InitSp(Spisoc:TypSp);
 VAR Test    : F;
     nfX1,nfX2,nfX3,nfX4,nfX5,nfX6,nfX7,nfX8     :  TypFx;
     nfY     : TypFy;
 BEGIN
    Test:=FC;     Test.Sp:=Spisoc;
    Sp[Spisoc]:=FC; Sp[Spisoc].Sp:=Spisoc; Sm[Spisoc]:=FC; Sm[Spisoc].Sp:=Spisoc;
    FOR nfY:=1 TO MaxFuNumYv DO  IF NOT ErrorFy[nfY]  THEN Test.nfY:=nfY;
     FOR nfX1:=Spisoc TO MaxFuNumXv DO  IF NOT ErrorFx[nfX1] THEN Test.nfX[1]:=nfX1;
       IF Spisoc>=2 THEN
          FOR nfX2:=Spisoc-1 TO nfX1-1 DO IF NOT ErrorFx[nfX2] THEN Test.nfX[2]:=nfX2;
            IF Spisoc>=3 THEN
             FOR nfX3:=Spisoc-2 TO nfX2-1 DO IF NOT ErrorFx[nfX3] THEN Test.nfX[3]:=nfX3;
              IF Spisoc>=4 THEN
               FOR nfX4:=Spisoc-3 TO nfX3-1 DO IF NOT ErrorFx[nfX4] THEN Test.nfX[4]:=nfX4;
                 IF Spisoc>=5 THEN
                  FOR nfX5:=Spisoc-4 TO nfX4-1 DO IF NOT ErrorFx[nfX5] THEN Test.nfX[5]:=nfX5;
                    IF Spisoc>=6 THEN
                     FOR nfX6:=Spisoc-5 TO nfX5-1 DO IF NOT ErrorFx[nfX6] THEN Test.nfX[6]:=nfX6;
                       IF Spisoc>=7 THEN
                        FOR nfX7:=Spisoc-6 TO nfX6-1 DO IF NOT ErrorFx[nfX7] THEN Test.nfX[7]:=nfX7;
                          IF Spisoc>=8 THEN
                          ELSE SetUpFu(Test)
                          END
                        END END  (* nfX7 *)
                       ELSE SetUpFu(Test)
                       END
                     END END  (* nfX6 *)
                    ELSE SetUpFu(Test)
                    END
                   END END  (* nfX5 *)
                 ELSE SetUpFu(Test)
                 END
                END END  (* nfX4 *)
              ELSE SetUpFu(Test)
              END
             END END  (* nfX3 *)
            ELSE SetUpFu(Test)
            END
        END END  (* nfX2 *)
     ELSE SetUpFu(Test)
     END
     END END  (* nfX1 *)
   END END; (* nfY *)

   IF Sp[Spisoc].Delta>1.E9 THEN Sp[Spisoc].Error:=TRUE   END
END InitSp;

PROCEDURE ToRecalcMuv;
VAR I:CARDINAL;
BEGIN  FOR I:=1 TO MaxFuNumX DO
         Sp[I]:=FC; Sp[I].Sp:=I;
         Sm[I]:=FC; Sm[I].Sp:=I
       END;
       ToSum :=TRUE;
END ToRecalcMuv;

PROCEDURE ToRecalculation;
VAR I:CARDINAL;
BEGIN  FOR I:=0 TO Kern.ClassMax DO              (* Signal with Load *)
         CollectionSp[I]:=FC; CollectionSp[I].Class:=I;
         CollectionSm[I]:=FC; CollectionSm[I].Class:=I
       END;
       ToRecalcMuv;
END ToRecalculation;


PROCEDURE  Fu(Fyy:F;X:LONGREAL;VAR Y:LONGREAL):BOOLEAN;
 VAR fx    : LONGREAL;
     Error : BOOLEAN;
     i     : CARDINAL;
 BEGIN ErrorSignal:=FALSE;   fx:=0.;
 IF Fyy.Error THEN Y:=0.; RETURN FALSE
 ELSE
  CASE Fyy.Co OF
  | TRUE:
   FOR i:=1 TO Fyy.Sp DO fx:=fx+Fyy.M[i]*Fyy.BsX[i].Bs(X*Fyy.Kc-Fyy.Ka);
   END;
   IF ErrorSignal THEN Y:=0.;           RETURN FALSE
   ELSE Y:=Fyy.BsY.BsRev(fx) /Fyy.Kd+Fyy.Kb; RETURN TRUE
   END (* if *)
  | FALSE:
   FOR i:=1 TO Fyy.Sp DO fx:=fx+Fyy.M[i]*Fx[Fyy.nfX[i]].Bs(X*Kc-Ka);
   END;
   IF ErrorSignal THEN Y:=0.;           RETURN FALSE
   ELSE Y:=Fy[Fyy.nfY] .BsRev(fx) /Kd+Kb; RETURN TRUE
   END (* if *)
  END (* case *)
 END (* if *)
END  Fu;

END Kern.
