
(* Simple formula (C) Sidyganov 1993 *)

IMPLEMENTATION MODULE Menus;

FROM   SYSTEM    IMPORT Registers;
FROM   Lib       IMPORT Intr, Sound,Delay,NoSound;
IMPORT Storage, BiosIO, IO, Str, MsMouse, graphics;

TYPE Type = (Int,LngReal,Card);
     UcSubmenu = POINTER TO Submenu;
     Submenu   = RECORD    Win                : WindowS.WinType;
                           ChildsQuantity     : CARDINAL;
                           Name               : ARRAY [0..50] OF CHAR;
                           Up,Down,Left,Right : UcSubmenu;
                           Key                : CARDINAL;
                           ForColor,BacColor  : WindowS.Color;
                           Length1            : CARDINAL;
                 END;
     Menu      = UcSubmenu;
     Cord      = ARRAY [0..10] OF SHORTCARD;
     Points    = RECORD Menu,Pmem, FirstChild, Parent     :UcSubmenu ;
                        LeftSubMenu,RightSubMenu,UpSubMenu:CARDINAL;
                        ChildsQuantity                    :INTEGER;
                 END;

CONST FloorQuantity = 6;
      R = Cord  (172,92,166,210,200,242,206,194,220,222,236);

VAR   FloorNumber : [1..FloorQuantity];
      ChildsNumber: INTEGER;
      Floor       : ARRAY [1..FloorQuantity] OF Points;
      First       : Points;
      Jirst       : Cord;
      BeginMenuX,BeginMenuY : CARDINAL;
      BacColor,  ForColor   : WindowS.Color;

CONST MaxStek = 15;
VAR   Stek    : ARRAY [1..MaxStek] OF Menu;
      NumStek : CARDINAL;

PROCEDURE Init(Name:ARRAY OF CHAR;FoCol,BaCol:INTEGER;X,Y:CARDINAL):Menu;
  VAR   Xw   :WindowS.WinDef;
        I    :CARDINAL;
  BEGIN Storage.ALLOCATE(First.Menu,SIZE(Submenu));
        First.Menu^.Left:=NIL; Jirst:=R;
        FOR I:=0 TO HIGH(Name) DO First.Menu^.Name[I]:=Name[I] END;
        FOR I:=HIGH(Name)+1 TO 50 DO First.Menu^.Name[I]:=' ' END;
        FOR I:=0 TO 10 DO Jirst[I]:=Jirst[I] DIV 2 END;
        WindowS.TextColor(WindowS.Yellow);
        BeginMenuX:=X; BeginMenuY:=Y;
        BacColor:=VAL(WindowS.Color,BaCol); ForColor:=VAL(WindowS.Color,FoCol);
        Xw.Foreground:=BacColor;            Xw.Background:=WindowS.Black;
        First.Menu^.BacColor:=BacColor;     First.Menu^.ForColor:=ForColor;
        Xw.X1:=X;Xw.Y1:=Y;Xw.X2:=X+11;      Xw.Y2:=Xw.Y1+1;
        Xw.CursorOn:=FALSE;                 Xw.FrameOn:=FALSE;
        Xw.WrapOn:=FALSE;                   Xw.Hidden:=TRUE;
        First.Menu^.Win:=WindowS.Open(Xw);  WindowS.DirectWrite(0,0,ADR(Jirst[0]),11);
        WindowS.Hide(First.Menu^.Win);
        RETURN First.Menu;
  END Init;

PROCEDURE submenu(XX1,With,YY1:CARDINAL);
 BEGIN FOR FloorNumber:=1 TO FloorQuantity-1 DO
           Floor[FloorQuantity-FloorNumber+1]:=Floor[FloorQuantity-FloorNumber]
       END;
       Floor[1]:=First;
       WITH First DO        ChildsQuantity:=0;
          LeftSubMenu:=XX1+BeginMenuX;
          RightSubMenu:=LeftSubMenu+With; UpSubMenu:=YY1+BeginMenuY;
          Storage.ALLOCATE(Menu,SIZE(Submenu));     Parent:=Menu;
          Parent^.Name:=Floor[1].Menu^.Name;
          Parent^.Left:=Floor[1].Menu;   Floor[1].Menu^.Right:=Parent;
          Parent^.Right:=NIL;
          Menu^.BacColor:=BacColor;      Menu^.ForColor:=ForColor;
       END
END submenu;


PROCEDURE menuitem(Text:ARRAY OF CHAR;K:CARDINAL);
  VAR  X   :WindowS.WinDef;
       I   :CARDINAL;
  BEGIN
    WITH First DO ChildsQuantity:=ChildsQuantity+1;
       X.X1:=LeftSubMenu+1;        X.Y1:=UpSubMenu+CARDINAL(ChildsQuantity)-1;
       X.X2:=RightSubMenu-1;       X.Y2:=X.Y1;
       X.Foreground:=WindowS.White(*LightGreen*);X.Background:=WindowS.White;
       X.CursorOn:=FALSE;          X.FrameOn:=FALSE;
       X.WrapOn:=FALSE;            X.Hidden:=TRUE;
       Pmem:=Menu;                 Storage.ALLOCATE(Menu,SIZE(Submenu));
       Menu^.Down:=Pmem;           Pmem^.Up  :=Menu;
       Menu^.Right:=NIL;           Menu^.Left:=Parent;
       Menu^.Win:=WindowS.Open(X); WindowS.Hide(Menu^.Win);
       IO.WrStr(Text);
       FOR I:=0 TO HIGH(Text) DO Menu^.Name[I]:=Text[I] END;
       FOR I:=HIGH(Text)+1 TO 50 DO Menu^.Name[I]:=' ' END;
       Menu^.Key:=K;
       Menu^.BacColor:=BacColor;   Menu^.ForColor:=ForColor;
       IF ChildsQuantity=1 THEN FirstChild:=Menu END;
    END
END menuitem;

PROCEDURE menuitemPlus(Wi:WindowS.WinType);
 BEGIN
    INC(NumStek);
    Storage.ALLOCATE(Stek[NumStek],SIZE(Submenu));
    Stek[NumStek]^.Win:=Wi;
    Stek[NumStek]^.Key:=First.Menu^.Key;
END menuitemPlus;

PROCEDURE popsublevel;
    VAR   X   :WindowS.WinDef;
    BEGIN
      WITH First DO
       FirstChild^.Down:=Menu;     Menu^.Up:=FirstChild;
       Parent^.Right:=FirstChild;
       X.X1:=LeftSubMenu;          X.Y1:=UpSubMenu-1;
       X.X2:=RightSubMenu;         X.Y2:=UpSubMenu+CARDINAL(ChildsQuantity);
       X.Foreground:=BacColor;     X.Background:=WindowS.Black;
       X.CursorOn:=FALSE;          X.FrameOn:=TRUE;
       X.WrapOn:=FALSE;            X.Hidden:=FALSE;
       X.FrameDef:=WindowS.SingleFrame;
       X.FrameFore:=ForColor;      X.FrameBack:=WindowS.Black;
       Parent^.Win:=WindowS.Open(X);     WindowS.Hide(Parent^.Win);
       Parent^.ChildsQuantity := ChildsQuantity;
       WindowS.SetTitle(Parent^.Win,Parent^.Name,WindowS.CenterUpperTitle);
       Menu:=FirstChild;            Menu:=Menu^.Down;
       FOR ChildsNumber:=1 TO ChildsQuantity DO
              IO.WrStr(Menu^.Name); IO.WrLn; Menu:=Menu^.Up;
       END;   IO.WrStr(Menu^.Name);
     END;
     First:=Floor[1];
     FOR FloorNumber:=1 TO FloorQuantity-1 DO
        Floor[FloorNumber]:=Floor[FloorNumber+1]
     END;
END popsublevel;

PROCEDURE BiosGetKey():CHAR;
VAR    A   : CHAR;
VAR R:Registers;
BEGIN
R.AH := 0;         Intr(R,016H);
        IF R.AL<>0 THEN    A:=CHR(R.AL);
        ELSE               A:=CHR(128+R.AH)
        END;
      RETURN A
END BiosGetKey;

PROCEDURE CurInWin(W:WindowS.WinType):BOOLEAN;
VAR x1,x2,y1,y2,r,c : CARDINAL;
    Dat             : MsMouse.MsData;
BEGIN IF W # NIL THEN
          MsMouse.GetPress(0,Dat);
          r:=CARDINAL(Dat.row);      c:=CARDINAL(Dat.col);
          x1:=W^.XA * 8;             x2:=W^.XB * 8;
          y1:=W^.YA * 14;            y2:=W^.YB * 14+14;
          IF (y1<r) AND (r<y2) AND (x1<c) AND (c<x2) THEN RETURN TRUE
          ELSE                                            RETURN FALSE
          END;
      ELSE                                            RETURN FALSE
      END
END CurInWin;

PROCEDURE CurInWin1(W:WindowS.WinType):BOOLEAN;
VAR x1,x2,y1,y2,r,c : CARDINAL;
    Dat             : MsMouse.MsData;
BEGIN IF W # NIL THEN
          MsMouse.GetPress(0,Dat);
          r:=CARDINAL(Dat.row);      c:=CARDINAL(Dat.col);
          x1:=W^.XA * 8;             x2:=W^.XB * 8;
          y1:=W^.YA * 14;            y2:=W^.YB * 14+15;
          IF (y1<r) AND (r<y2) AND (x1<c)
                    AND (c<x2) AND NOT W^.WDef.Hidden
                                                       THEN RETURN TRUE
          ELSE                                              RETURN FALSE
          END;
      ELSE                                            RETURN FALSE
      END
END CurInWin1;

PROCEDURE StekWin(VAR Key:INTEGER):BOOLEAN;
VAR I:CARDINAL;
BEGIN
  FOR I:=1 TO NumStek DO
     IF CurInWin1(Stek[I]^.Win) THEN
        Key:=Stek[I]^.Key;
        RETURN TRUE
    END
  END;
  RETURN FALSE
END StekWin;

PROCEDURE GetKey():CHAR;
VAR  Dat : MsMouse.MsData;
     A   : CHAR;
BEGIN
 LOOP
  IF BiosIO.KeyPressed()  THEN A:= BiosGetKey(); EXIT END;
  IF IniMous<10 THEN
    Dat.right_pressed:=FALSE;    MsMouse.GetPress(1,Dat);
    IF Dat.right_pressed               THEN A:= 'R'  END;

    Dat.right_pressed:=FALSE;    MsMouse.GetRelease(1,Dat);
    IF Dat.right_pressed AND (A='R')   THEN A:= 'r'; EXIT END;

    Dat.left_pressed:=FALSE;     MsMouse.GetPress(0,Dat);
    IF Dat.left_pressed                THEN A:= 'L'  END;

    Dat.left_pressed:=FALSE;     MsMouse.GetRelease(0,Dat);
    IF Dat.left_pressed AND (A='L')    THEN A:= 'l'; EXIT END;
  END
 END;
 RETURN A
END GetKey;

PROCEDURE InMenu(VAR MenuTest:Menu):CARDINAL;
VAR   Char   : CHAR;
      KeyEnd : INTEGER;
      MenuTest2 : Menu;
      I    : CARDINAL;
VAR   newW : Menu;
BEGIN
  graphics.setfillstyle(graphics.SOLID_FILL,1);
  (*Pip;*)                           MenuTest:=MenuTest^.Right;
  WindowS.PutOnTop(MenuTest^.Win);   MenuTest:=MenuTest^.Right;
  LOOP MenuTest2:=MenuTest^.Left;

     WindowS.SetFrame(MenuTest2^.Win,WindowS.DoubleFrame,MenuTest2^.ForColor,
                                                           WindowS.Black);
     WindowS.Hide(MenuTest^.Win);
     graphics.bar(MenuTest^.Win^.XA * 8, MenuTest^.Win^.YA * 14+2,
                  MenuTest^.Win^.XB * 8+8, MenuTest^.Win^.YB * 14+13);
     WindowS.PutOnTop(MenuTest^.Win); newW:=MenuTest;

     IF IniMous<10 THEN MsMouse.Cursor(TRUE) END;
     Char:= GetKey();
     IF IniMous<10 THEN MsMouse.Cursor(FALSE) END;
     CASE Char OF
       | 'l': I:=0;
              LOOP INC(I);
               IF (I>MenuTest2^.ChildsQuantity) THEN
                IF StekWin(KeyEnd) THEN
                     WindowS.Hide(MenuTest^.Win);
                     MenuTest:=MenuTest^.Left;
                     MenuTest:=MenuTest^.Left;
                     RETURN KeyEnd; EXIT
                END;
               EXIT
               END;
               newW:=newW^.Up;
               IF CurInWin(newW^.Win)  THEN
                  IF (MenuTest=newW) THEN Char:=CHR(13); EXIT
                  ELSE  WindowS.Hide(MenuTest^.Win); MenuTest:=newW;
                  END
                END;
              END;
     END;

     CASE Char OF
       | CHR(128+75),CHR(27),'r':
            WindowS.Hide(MenuTest^.Win);
            FOR I:=1 TO MenuTest^.Left^.ChildsQuantity  DO
              WindowS.Hide(MenuTest^.Win);
              MenuTest:=MenuTest^.Up;
            END;
            MenuTest:=MenuTest^.Left;
            WindowS.PutOnTop(MenuTest^.Win);
            WindowS.Hide(MenuTest^.Win);     MenuTest:=MenuTest^.Left;
            IF MenuTest^.Left=NIL THEN      WindowS.PutOnTop(MenuTest^.Win);
              (*IO.WrLn;IO.WrStr('362-78-77');*)    KeyEnd:=0; (*Pip;*)
              WindowS.Hide(MenuTest^.Win);
              EXIT END;
            MenuTest2:=MenuTest^.Left;      WindowS.PutOnTop(MenuTest2^.Win);
       | CHR(128+77),CHR(13):
              IF MenuTest^.Right<>NIL THEN
                WindowS.Hide(MenuTest^.Win);
                MenuTest2:=MenuTest^.Left;
                WindowS.SetFrame(MenuTest2^.Win,WindowS.SingleFrame,
                              MenuTest2^.ForColor,WindowS.Black);
                MenuTest:=MenuTest^.Right;   WindowS.PutOnTop(MenuTest^.Win);
                MenuTest:=MenuTest^.Right
              ELSE KeyEnd:=MenuTest^.Key;   WindowS.Hide(MenuTest^.Win);
                 MenuTest:=MenuTest^.Left;
                 MenuTest:=MenuTest^.Left;  (* Pip;*)
                 EXIT END;
       | CHR(128+72): WindowS.Hide(MenuTest^.Win); MenuTest:=MenuTest^.Down;
       | CHR(128+80): WindowS.Hide(MenuTest^.Win); MenuTest:=MenuTest^.Up;
     ELSE Pip;
     END; (*Pip;*)
   END;
   RETURN KeyEnd
END InMenu;

PROCEDURE Pip;
 VAR
    I,I2 : CARDINAL;
  BEGIN
    I2 := 0;
    REPEAT
      INC(I2);
      Delay(200);
      Sound(400);
      Delay(4);
      Sound(300);
      Delay(4);
      Sound(100);
      Delay(10);
      NoSound;
    UNTIL I2 <= 1;
  END Pip;

  PROCEDURE Horse;
  VAR
    I,I2 : CARDINAL;
  BEGIN
    I2 := 0;
    REPEAT
      INC(I2);
      FOR I := 1 TO 3 DO
        IF I = 2 THEN
          Sound(250)
        ELSE
          Sound(100);
        Delay(7);
        NoSound;
        Delay(90);
      END;
      END;
      Sound(300);
      Delay(15);
      NoSound;
    UNTIL I2 <= 1;
  END Horse;


PROCEDURE CommandESC(VAR MenuTest:Menu);
BEGIN
            WindowS.Hide(MenuTest^.Win);
            MenuTest:=MenuTest^.Left;
            WindowS.Hide(MenuTest^.Win);
            MenuTest:=MenuTest^.Left;
            WindowS.Hide(MenuTest^.Win);
END CommandESC;

PROCEDURE ClearAnounse();
 BEGIN WindowS.PutOnTop(Anounse); WindowS.Clear; WindowS.GotoXY(0,0);
       Horse;
END ClearAnounse;

PROCEDURE WrLnRealAnounse(Stop : BOOLEAN; s : ARRAY OF CHAR; a : LONGREAL);
 VAR C : CHAR;
 BEGIN WindowS.PutOnTop(Anounse); IO.WrLn;   (* Pip;*)
       IO.WrStr( s );             IO.WrLngReal( a, 6, 12 );
       IF Stop THEN C:= GetKey(); WindowS.Hide(Anounse) END
END WrLnRealAnounse;

PROCEDURE WrIntAnounse(Stop : BOOLEAN; s : ARRAY OF CHAR; n : INTEGER);
 VAR C : CHAR;
 BEGIN WindowS.PutOnTop(Anounse); IO.WrLn;  (*Pip;*)
       IO.WrStr( s );             IO.WrInt( n, 4 );
       IF Stop THEN
         LOOP C:= GetKey();
              IF (C=CHR(13))OR(C=CHR(27)) THEN EXIT END
         END;
         WindowS.Hide(Anounse)
       END;
END WrIntAnounse;

PROCEDURE WrStrAnounse(Stop : BOOLEAN; s : ARRAY OF CHAR);
 VAR C : CHAR;
 BEGIN WindowS.PutOnTop(Anounse); IO.WrLn;
       IO.WrStr( s );
       IF Stop THEN C:= GetKey(); WindowS.Hide(Anounse) END
END WrStrAnounse;

PROCEDURE Init0;
  BEGIN
   Anounse:=WindowS.Open(WindowS.WinDef(41,11,78,15,    WindowS.LightRed,
                         WindowS.Red,FALSE,FALSE,TRUE,TRUE,
                         WindowS.SingleFrame,WindowS.LightRed,WindowS.Red));
   WindowS.SetTitle(Anounse,'    ',WindowS.CenterUpperTitle);
(* WindowS.SetTitle(Anounse,' Announcement ',WindowS.CenterUpperTitle);*)
   IniMous:=MsMouse.Reset();
   NumStek:=0;
END Init0;

END Menus.
