
(* Simple formula (C) Sidyganov 1993 *)

IMPLEMENTATION MODULE MuvMul;
IMPORT IO,Menus,WindowS,Storage(*Kern,Processs,TextView,Storage,File*);

VAR   XY   : TyDat;
      Post : BOOLEAN;

VAR WinMuv                     : WindowS.WinType;
    oldKa, oldKb, oldKc, oldKd : LONGREAL;
PROCEDURE MuvXsmol;
 VAR n        :CARDINAL;
BEGIN
          IF (Cty IN Mode) THEN  EXCL(Mode,Cty);
           FOR n:=1 TO MaxPointNum DO X^[n]:=X^[n]/Kc END;
           Kc:=1.;
          END;
          INCL(Mode,Aty);
          FOR n:=1 TO MaxPointNum DO X^[n]:=X^[n]+oldKa-Ka END;
          WrFx:= WrF[A];
END MuvXsmol;

PROCEDURE MuvX():BOOLEAN;
 BEGIN
  IF (XYty IN Mode) AND NOT Post THEN Post:=TRUE; RETURN MuvY();
  ELSE
      Menus.ClearAnounse();
      IF NOT Post THEN
        (*Menus.WrStrAnounse( FALSE,' Enter the X shifting            ');
          *)
          Menus.WrStrAnounse( FALSE,'  ᬥ饭e   X          ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          WindowS.Use(WinMuv);     IO.WrStr(' a=');
      ELSE
        (*Menus.WrStrAnounse( FALSE,' Enter the Y shifting            ');
          *)
          Menus.WrStrAnounse( FALSE,'  ᬥ饭e   Y          ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          WindowS.Use(WinMuv); IO.WrStr(' b=');
      END;
      Post:=FALSE;
      oldKa:=Ka;
      Ka:=IO.RdLngReal();
      WindowS.Hide(Menus.Anounse);WindowS.Hide(WinMuv);
      IF WindowS.Fortuna THEN
         MuvXsmol;
         RETURN TRUE;
      ELSE  Ka:=oldKa; RETURN FALSE;
      END;
  END
END MuvX;

PROCEDURE MuvXavt(K:LONGREAL):BOOLEAN;
 BEGIN
      oldKa:=Ka;
      Ka:=K;
      MuvXsmol;
      RETURN TRUE
END MuvXavt;

PROCEDURE MulXsmol;
 VAR n        :CARDINAL;
 BEGIN
          IF (Aty IN Mode) THEN EXCL(Mode,Aty);
           FOR n:=1 TO MaxPointNum DO X^[n]:=X^[n]+Ka END;
           Ka:=0.
          END;
          INCL(Mode,Cty);
          FOR n:=1 TO MaxPointNum DO X^[n]:=X^[n]/oldKc*Kc END;

          WrFx:= WrF[C];
END MulXsmol;

PROCEDURE MulX():BOOLEAN;
 VAR n:CARDINAL;
 BEGIN
  IF (XYty IN Mode) AND NOT Post THEN Post:=TRUE; RETURN MulY();
  ELSE
      Menus.ClearAnounse();
      IF NOT Post THEN
        (*Menus.WrStrAnounse( FALSE,' Enter the X stretching          ');
          *)
          Menus.WrStrAnounse( FALSE,'  殮  X           ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          WindowS.Use(WinMuv); IO.WrStr(' a=');
      ELSE
        (*Menus.WrStrAnounse( FALSE,' Enter the Y stretching          ');
          *)
          Menus.WrStrAnounse( FALSE,'  殮  Y           ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          WindowS.Use(WinMuv); IO.WrStr(' b=');
      END;
      Post:=FALSE;
      oldKc:=Kc;
      Kc:=IO.RdLngReal();
      WindowS.Hide(Menus.Anounse);WindowS.Hide(WinMuv);
      IF WindowS.Fortuna THEN
         MulXsmol;
         RETURN TRUE;
      ELSE  Kc:=oldKc;  RETURN FALSE;
      END;
   END
END MulX;

PROCEDURE MulXavt(K:LONGREAL):BOOLEAN;
 BEGIN
      oldKc:=Kc;
      Kc:=K;
      MulXsmol;
      RETURN TRUE
END MulXavt;

PROCEDURE MuvYsmol;
 VAR n        :CARDINAL;
BEGIN
            IF (Dty IN Mode) THEN  EXCL(Mode,Dty);
             FOR n:=1 TO MaxPointNum DO Y^[n]:=Y^[n]/Kd END;
             Kd:=1.
            END;
            INCL(Mode,Bty);
            FOR n:=1 TO MaxPointNum DO Y^[n]:=Y^[n]+oldKb-Kb END;

            WrFy:= WrF[B];
END MuvYsmol;

PROCEDURE MuvY():BOOLEAN;
 VAR n:CARDINAL;
 BEGIN
  IF (XYty IN Mode) AND NOT Post THEN Post:=TRUE; RETURN MuvX();
  ELSE
      Menus.ClearAnounse();
      IF NOT Post THEN
        (*Menus.WrStrAnounse( FALSE,' Enter the Y shifting            ');
          *)
          Menus.WrStrAnounse( FALSE,'  ᬥ饭e   Y          ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          WindowS.Use(WinMuv); IO.WrStr(' b=');
      ELSE
          Menus.WrStrAnounse( FALSE,'  ᬥ饭e   X          ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          WindowS.Use(WinMuv);     IO.WrStr(' a=');
      END;
      Post:=FALSE;
      oldKb:=Kb;
      Kb:=IO.RdLngReal();
      WindowS.Hide(Menus.Anounse);WindowS.Hide(WinMuv);
      IF WindowS.Fortuna THEN
          MuvYsmol;
          RETURN TRUE;
      ELSE  Kb:=oldKb;  RETURN FALSE;
      END;
   END
END MuvY;

PROCEDURE MuvYavt(K:LONGREAL):BOOLEAN;
 BEGIN
      oldKb:=Kb;
      Kb:=K;
      MuvYsmol;
      RETURN TRUE
END MuvYavt;

PROCEDURE MulYsmol;
 VAR n        :CARDINAL;
BEGIN
          IF (Bty IN Mode) THEN EXCL(Mode,Bty);
           FOR n:=1 TO MaxPointNum DO Y^[n]:=Y^[n]+Kb END;
           Kb:=0.
          END;
          INCL(Mode,Dty);
          FOR n:=1 TO MaxPointNum DO Y^[n]:=Y^[n]/oldKd*Kd END;
          WrFy:= WrF[D];
END MulYsmol;

PROCEDURE MulY():BOOLEAN;
 VAR n:CARDINAL;
 BEGIN
  IF (XYty IN Mode) AND NOT Post THEN Post:=TRUE; RETURN MulX();
  ELSE
      Menus.ClearAnounse();
      IF NOT Post THEN
        (*Menus.WrStrAnounse( FALSE,' Enter the Y stretching          ');
          *)
          Menus.WrStrAnounse( FALSE,'  殮  Y           ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          WindowS.Use(WinMuv); IO.WrStr(' b=');
      ELSE
        (*Menus.WrStrAnounse( FALSE,' Enter the X stretching          ');
          *)
          Menus.WrStrAnounse( FALSE,'  殮  X           ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          Menus.WrStrAnounse( FALSE,'                                 ');
          WindowS.Use(WinMuv); IO.WrStr(' a=');
      END;
      Post:=FALSE;
      oldKd:=Kd;
      Kd:=IO.RdLngReal();
      WindowS.Hide(Menus.Anounse);WindowS.Hide(WinMuv);
      IF WindowS.Fortuna THEN
          MulYsmol;
          RETURN TRUE;
      ELSE  Kd:=oldKd;  RETURN FALSE;
      END;
   END
END MulY;

PROCEDURE MulYavt(K:LONGREAL):BOOLEAN;
 BEGIN
      oldKd:=Kd;
      Kd:=K;
      MulYsmol;
      RETURN TRUE
END MulYavt;

PROCEDURE XtoY;
VAR K                   : LONGREAL;
    AinM,BinM,CinM,DinM : BOOLEAN;
BEGIN
      IF (XYty IN Mode) THEN
         EXCL(Mode,XYty);
         WrF:= WrConst;
      ELSE
         INCL(Mode,XYty);
         WrF:= WrConstRev;
      END;
      XY:=X;    X:=Y;       Y:=XY;
      XY:=Xold; Xold:=Yold; Yold:=XY;
      K:=Ka;    Ka:=Kb;     Kb:=K;
      K:=Kc;    Kc:=Kd;     Kd:=K;

      IF (Aty IN Mode) THEN      AinM:=TRUE
                                 ELSE      AinM:=FALSE
      END;                       EXCL(Mode,Aty);
      IF (Bty IN Mode) THEN      BinM:=TRUE
                                 ELSE      BinM:=FALSE
      END;                       EXCL(Mode,Bty);
      IF (Dty IN Mode) THEN      DinM:=TRUE
                                 ELSE      DinM:=FALSE
      END;                       EXCL(Mode,Dty);
      IF (Cty IN Mode) THEN      CinM:=TRUE
                                 ELSE      CinM:=FALSE
      END;                       EXCL(Mode,Cty);
      WrFx:=WrF[x];
      WrFy:=WrF[y];

      IF AinM THEN INCL(Mode,Bty);
                   WrFy:=WrF[B];
      END;
      IF BinM THEN INCL(Mode,Aty);
                   WrFx:=WrF[A];
      END;
      IF CinM THEN INCL(Mode,Dty);
                   WrFy:=WrF[D];
      END;
      IF DinM THEN INCL(Mode,Cty);
                   WrFx:=WrF[C];
      END;
END XtoY;

VAR n:CARDINAL;
PROCEDURE RecoverX():BOOLEAN;
 BEGIN
  IF (XYty IN Mode) AND NOT Post THEN Post:=TRUE; RETURN RecoverY()
  ELSE Post:=FALSE;
           WrFx:= WrF[x];
           IF (Aty IN Mode) THEN EXCL(Mode,Aty);
            FOR n:=1 TO MaxPointNum DO X^[n]:=X^[n]+Ka END;
            Ka:=0.; RETURN TRUE;
           END;
           IF (Cty IN Mode) THEN  EXCL(Mode,Cty);
            FOR n:=1 TO MaxPointNum DO X^[n]:=X^[n]/Kc END;
            Kc:=1.;  RETURN TRUE;
           END;
           RETURN FALSE
  END
END RecoverX;

PROCEDURE RecoverY():BOOLEAN;
 BEGIN
  IF (XYty IN Mode) AND NOT Post THEN Post:=TRUE; RETURN RecoverX()
  ELSE Post:=FALSE;
           WrFy:= WrF[y];
           IF (Bty IN Mode) THEN EXCL(Mode,Bty);
            FOR n:=1 TO MaxPointNum DO Y^[n]:=Y^[n]+Kb END;
            Kb:=0.; RETURN TRUE;
           END;
           IF (Dty IN Mode) THEN  EXCL(Mode,Dty);
            FOR n:=1 TO MaxPointNum DO Y^[n]:=Y^[n]/Kd END;
            Kd:=1.; RETURN TRUE;
           END;
           RETURN FALSE
    END
END RecoverY;

PROCEDURE InitBasis;
 BEGIN
 IF (XYty IN Mode) THEN
       XY:=X;    X:=Y;       Y:=XY;
       XY:=Xold; Xold:=Yold; Yold:=XY;
 END;
 IF (Aty IN Mode) OR (Cty IN Mode) THEN
   FOR n:=1 TO MaxPointNum DO X^[n]:=Xold^[n] END
 END;
 IF (Bty IN Mode) OR (Dty IN Mode) THEN
   FOR n:=1 TO MaxPointNum DO Y^[n]:=Yold^[n] END
 END;

 Mode:=TypMode{};   Ka:=0.; Kb:=0.; Kc:=1.; Kd:=1.;
 WrF:= WrConst;     WrFx:= WrF[x];  WrFy:= WrF[y];
 Post:=FALSE;
END InitBasis;

PROCEDURE InPutPointTxt():BOOLEAN;  (* dubl in Poi.mod *)
VAR Yes:CHAR;
BEGIN
 IF MaxPointNum<12 (*MaxArray*) THEN
   INC(MaxPointNum);
   WindowS.Use(Menus.Anounse); WindowS.GotoXY(0,0);
(*   Menus.WrIntAnounse( FALSE,'Enter X-coordinate of the point No.',MaxPointNum);*)
   Menus.WrIntAnounse( FALSE,' न X 窨 No.',MaxPointNum);
   Menus.WrStrAnounse( FALSE,'                                 ');
   Menus.WrStrAnounse( FALSE,'                                 ');
   WindowS.Use(WinX); IO.WrStr('X=');
   IF (XYty IN Mode) THEN
        Yold^[MaxPointNum]:=IO.RdLngReal();
        Y^[MaxPointNum]   :=Yold^[MaxPointNum]*Kd-Kb;
   ELSE Xold^[MaxPointNum]:=IO.RdLngReal();
        X^[MaxPointNum]   :=Xold^[MaxPointNum]*Kc-Ka;
   END;
   IF WindowS.Fortuna THEN
     WindowS.Use(Menus.Anounse); WindowS.GotoXY(0,0);
(*     Menus.WrIntAnounse( FALSE,'Enter X-coordinate of the point No.',MaxPointNum);*)
     Menus.WrIntAnounse( FALSE,' न Y 窨 No.',MaxPointNum);
     Menus.WrStrAnounse( FALSE,'                                 ');
     Menus.WrStrAnounse( FALSE,'                                 ');
     WindowS.Use(WinY); IO.WrStr('Y=');
     IF (XYty IN Mode) THEN
          Xold^[MaxPointNum]:=IO.RdLngReal();
          X^[MaxPointNum]   :=Xold^[MaxPointNum]*Kc-Ka;
     ELSE Yold^[MaxPointNum]:=IO.RdLngReal();
          Y^[MaxPointNum]   :=Yold^[MaxPointNum]*Kd-Kb;
     END;
     IF WindowS.Fortuna THEN
       QuestionSave:=TRUE;
       WindowS.Hide(Menus.Anounse); WindowS.Hide(WinX);  WindowS.Hide(WinY);
       RETURN TRUE
     ELSE DEC(MaxPointNum);
     END
   ELSE DEC(MaxPointNum);
   END;
   WindowS.Hide(Menus.Anounse); WindowS.Hide(WinX);  WindowS.Hide(WinY);
   RETURN FALSE
 ELSE
   WindowS.Use(Menus.Anounse); WindowS.GotoXY(0,0);
(*
   Menus.WrStrAnounse(FALSE,'    In this version (demonstration)  ');
   Menus.WrStrAnounse(FALSE,' the point number are restricted to  ');
   Menus.WrIntAnounse( TRUE,'            N < ',INTEGER(MaxPointNum));
   *)
   Menus.WrStrAnounse(FALSE,'         ᫮ 祪          ');
   Menus.WrStrAnounse(FALSE,'   ᮪饭 ਠ ࠭祭:');
   Menus.WrIntAnounse( TRUE,'            N < ',12  (*INTEGER(MaxPointNum)*));
   RETURN FALSE
 END
END InPutPointTxt;

PROCEDURE Init;
 BEGIN
 WinMuv:= WindowS.Open(WindowS.WinDef(45,13,75,15,WindowS.LightGray, WindowS.Black,
      FALSE,TRUE,TRUE,TRUE,WindowS.SingleFrame,WindowS.LightGray, WindowS.Black));

 Mode:=TypMode{};  Ka:=0.; Kb:=0.; Kc:=1.; Kd:=1.;
 WrF:= WrConst; WrFx:= WrF[x]; WrFy:= WrF[y];
 Post:=FALSE;

 WinX:= WindowS.Open(WindowS.WinDef(41,13,59,15,WindowS.LightGray, WindowS.Black,
      FALSE,TRUE,TRUE,TRUE,WindowS.SingleFrame,WindowS.LightGray, WindowS.Black));
(* WindowS.SetTitle( WinX,'Enter X',WindowS.CenterUpperTitle);*)
 WindowS.SetTitle( WinX,'  X',WindowS.CenterUpperTitle);

 WinY:= WindowS.Open(WindowS.WinDef(60,13,78,15,WindowS.LightGray, WindowS.Black,
      FALSE,TRUE,TRUE,TRUE,WindowS.SingleFrame,WindowS.LightGray, WindowS.Black));
(* WindowS.SetTitle( WinY,'Enter Y',WindowS.CenterUpperTitle);*)
 WindowS.SetTitle( WinY,'  Y',WindowS.CenterUpperTitle);

 Storage.ALLOCATE(X,SIZE(TyDty));
 Storage.ALLOCATE(Y,SIZE(TyDty));
 Storage.ALLOCATE(Xold,SIZE(TyDty));
 Storage.ALLOCATE(Yold,SIZE(TyDty));

END Init;

END MuvMul.
