
(* Simple formula (C) Sidyganov 1993 *)

IMPLEMENTATION MODULE TextView;
FROM MATHLIB IMPORT Sqrt,Log10;
IMPORT IO,Kern,Menus,Str,graphics,File,MuvMul;
CONST tel=7877;

PROCEDURE WrInFile(Fu:Kern.F);
VAR i    : CARDINAL;
    Send : Kern.F;
BEGIN
 IF NOT Fu.Co THEN
    Fu:=Kern.Reform(Fu)
 END;
 FIO.WrLn(F);
 (*FIO.WrStr(F,'Standart Residual  = ');*)
 FIO.WrStr(F,'।筮 ⪫  ');
 IF (MuvMul.XYty IN Fu.Mode) THEN FIO.WrStr(F,' X ')
                           ELSE FIO.WrStr(F,' Y ') END;
 FIO.WrStr(F,' = ');
 FIO.WrLngReal(F,Sqrt(Fu.Delta2)/LONGREAL(MuvMul.MaxPointNum),5,11); FIO.WrLn(F);
 (*FIO.WrStr(F,'Maximum Residual  = ');*)
 FIO.WrStr(F,'ᨬ쭮 ⪫   ');
 IF (MuvMul.XYty IN Fu.Mode) THEN   FIO.WrStr(F,' X ')
                           ELSE   FIO.WrStr(F,' Y ') END;
 FIO.WrStr(F,' = ');
 FIO.WrLngReal(F,Fu.Delta,5,11);  FIO.WrLn(F);
 FIO.WrStr(F,Fu.BsY.TxRev1);
 FIO.WrStr(F,Fu.BsY.TxRev2);      FIO.WrLn(F);
 FOR i:=1 TO Fu.Sp-1 DO
   FIO.WrLngReal(F,Fu.M[i],15,21);FIO.WrStr(F,Fu.BsX[i].Tx1);
      FIO.WrStr(F,Fu.BsX[i].Tx2); FIO.WrStr(F,Fu.BsX[i].Tx3);
   FIO.WrStr(F,' + ');            FIO.WrLn(F)
 END; (* for *)
 i := Fu.Sp;
 FIO.WrLngReal(F,Fu.M[i],15,21);  FIO.WrStr(F,Fu.BsX[i].Tx1);
 FIO.WrStr(F,Fu.BsX[i].Tx2);      FIO.WrStr(F,Fu.BsX[i].Tx3);
 FIO.WrStr(F,'      ');
 FIO.WrStr(F,Fu.BsY.TxRev3);   FIO.WrLn(F);
 IF (MuvMul.Aty IN Fu.Mode) THEN
          FIO.WrStr(F,'     a=');  FIO.WrLngReal(F,Fu.Ka,15,15);
 END;
 IF (MuvMul.Bty IN Fu.Mode) THEN
          FIO.WrStr(F,'     b=');  FIO.WrLngReal(F,Fu.Kb,15,15);
 END;
 IF (MuvMul.Cty IN Fu.Mode) THEN
          FIO.WrStr(F,'     a=');  FIO.WrLngReal(F,Fu.Kc,15,15);
 END;
 IF (MuvMul.Dty IN Fu.Mode) THEN
          FIO.WrStr(F,'     b=');  FIO.WrLngReal(F,Fu.Kd,15,15);
 END;
 FIO.WrLn(F);
END WrInFile;

VAR    Len               : LONGREAL;
PROCEDURE Wr(Fu:Kern.F);
VAR R:ARRAY[0..100] OF CHAR;
    D    : LONGREAL;
    marc : ARRAY [0..11] OF CHAR;
    OK   : BOOLEAN;
    i,Class,NewClass    : CARDINAL;
    horPos,WidthD,OldColor : INTEGER;
BEGIN
IF NOT Fu.Error THEN horPos:=10;
  IF NOT Fu.Co THEN Fu:=Kern.Reform(Fu) END;
  Str.Concat(R,'   ',Fu.BsY.TxRev1); Str.Append(R,Fu.BsY.TxRev2);
  graphics.outtextxy(horPos,TextView.POSwGeneral,R);
  horPos:=graphics.textwidth(R)+horPos;
  FOR i:=1 TO Fu.Sp DO
     IF Fu.M[i]>0. THEN Str.Copy(R,'+')
     ELSE Str.Copy(R,' ')
     END;
     Str.RealToStr(Fu.M[i],5,TRUE,marc,OK); IF OK THEN Str.Append(R,marc) END;
     Str.Append(R,Fu.BsX[i].Tx1); Str.Append(R,Fu.BsX[i].Tx2);Str.Append(R,Fu.BsX[i].Tx3);
     WidthD:=graphics.textwidth(R);
     IF 627-horPos < WidthD THEN TextView.POSwGeneral:=TextView.POSwGeneral+10;
          horPos:=50
     END;
     graphics.outtextxy(horPos,TextView.POSwGeneral,R);
     horPos:=graphics.textwidth(R)+horPos;
  END; (* for *)

  Str.Copy(R,Fu.BsY.TxRev3);  graphics.settextstyle(2,0,4);
  graphics.outtextxy(horPos,TextView.POSwGeneral,R);
  horPos:=graphics.textwidth(R)+horPos;

  D:=Sqrt(Fu.Delta2)/LONGREAL(MuvMul.MaxPointNum);
  IF D>1.E-50 THEN Len:=-Log10(D)
  ELSE Len:=50.
  END;

  Str.RealToStr(D,5,TRUE,marc,OK);IF OK THEN Str.Concat(R,' ',marc) END;
  Str.Append(R,' ');
  Str.RealToStr(Fu.Delta,5,TRUE,marc,OK);IF OK THEN  Str.Append(R,marc) END;
  WidthD:=graphics.textwidth(R);
  IF 627-horPos < WidthD THEN TextView.POSwGeneral:=TextView.POSwGeneral+10;
  END;
  OldColor:=graphics.getcolor();
  graphics.setcolor(11);
  graphics.outtextxy(626-WidthD,TextView.POSwGeneral,R);
  TextView.POSwGeneral:=TextView.POSwGeneral+10;
  graphics.setcolor(OldColor);
 END (* not Error *)

END Wr;

PROCEDURE WrInKoff(Fu:Kern.F;N:CARDINAL);
VAR i    : CARDINAL;
    D    : LONGREAL;
    Send : Kern.F;
    marc : ARRAY [0..20] OF CHAR;
    OK   : BOOLEAN;
    R:ARRAY[0..100] OF CHAR;
BEGIN
     graphics.setcolor(11);
     graphics.settextstyle(2,0,4);
     Clear(TextView.WinFuDelt,1);
     D:=Sqrt(Fu.Delta2)/LONGREAL(MuvMul.MaxPointNum);
     Str.RealToStr(D,5,TRUE,marc,OK);IF OK THEN Str.Concat(R,' ',marc) END;
     Str.Concat(R,R,'  ');
     Str.RealToStr(Fu.Delta,5,TRUE,marc,OK);IF OK THEN  Str.Concat(R,R,marc) END;
     Str.Concat(R,R,'                ');

     graphics.setfillstyle(graphics.SOLID_FILL,4);
     IF NOT Fu.Co THEN
        Fu:=Kern.Reform(Fu)
     END;
     Str.Concat(R,R,Fu.BsY.TxRev1); Str.Concat(R,R,Fu.BsY.TxRev2);
     graphics.outtextxy(20,POSwGeneral,R);
     POSwGeneral:=POSwGeneral+10;
     FOR i:=1 TO Fu.Sp-1 DO
         IF Fu.M[i]>0. THEN Str.Concat(R,' ',' +') ELSE Str.Concat(R,' ',' ') END;
         Str.RealToStr(Fu.M[i],15,TRUE,marc,OK);
         IF OK THEN Str.Concat(R,R,marc) END;
         Str.Concat(R,R,Fu.BsX[i].Tx1); Str.Concat(R,R,Fu.BsX[i].Tx2);
         Str.Concat(R,R,Fu.BsX[i].Tx3);
         Str.Concat(R,R,' +  ');
         IF i=N THEN graphics.bar(185,POSwGeneral+1,370,POSwGeneral+9);
         END;
         graphics.outtextxy(180,POSwGeneral,R);
         Str.RealToStr(Ustoich[i],7,TRUE,marc,OK);
         graphics.outtextxy(500,POSwGeneral,marc);
         POSwGeneral:=POSwGeneral+10;
     END; (* for *)
     i := Fu.Sp;
     IF i=N THEN graphics.bar(185,POSwGeneral+1,370,POSwGeneral+9);
     END;
     IF Fu.M[i]>0. THEN Str.Concat(R,' ',' +') ELSE Str.Concat(R,' ',' ') END;
     Str.RealToStr(Fu.M[i],15,TRUE,marc,OK);
     IF OK THEN Str.Concat(R,R,marc) END;
     Str.Concat(R,R,Fu.BsX[i].Tx1); Str.Concat(R,R,Fu.BsX[i].Tx2);
     Str.Concat(R,R,Fu.BsX[i].Tx3);
     Str.Concat(R,R,Fu.BsY.TxRev3);
     graphics.settextstyle(2,0,4);
     graphics.outtextxy(180,POSwGeneral,R);
     Str.RealToStr(Ustoich[i],7,TRUE,marc,OK);
     graphics.outtextxy(500,POSwGeneral,marc);
     POSwGeneral:=POSwGeneral+10;
END WrInKoff;

PROCEDURE WrABCD;
TYPE abType = ARRAY [0..5] OF CHAR;
CONST a  = abType(' ',' ',' ',' ','a','=');
      b  = abType(' ',' ',' ',' ','b','=');
VAR  ab,ba  : abType;
    R    : ARRAY[0..100] OF CHAR;
    D    : LONGREAL;
    marc : ARRAY [0..11] OF CHAR;
    OK,ModeNotEmpti   : BOOLEAN;
BEGIN
  IF (MuvMul.XYty IN MuvMul.Mode) THEN ab:=b; ba:=a
                              ELSE ab:=a; ba:=b
  END;
  Str.Concat(R,'  ','   ');ModeNotEmpti:=FALSE;
  IF (MuvMul.Aty IN MuvMul.Mode) THEN ModeNotEmpti:=TRUE;
      Str.Concat(R,R,ab);
      Str.RealToStr(MuvMul.Ka,5,TRUE,marc,OK);IF OK THEN Str.Concat(R,R,marc) END;
      Str.Concat(R,R,';');
  END;
  IF (MuvMul.Bty IN MuvMul.Mode) THEN ModeNotEmpti:=TRUE;
      Str.Concat(R,R,ba);
      Str.RealToStr(MuvMul.Kb,5,TRUE,marc,OK);IF OK THEN Str.Concat(R,R,marc) END;
      Str.Concat(R,R,';');
  END;
  IF (MuvMul.Cty IN MuvMul.Mode) THEN ModeNotEmpti:=TRUE;
      Str.Concat(R,R,ab);
      Str.RealToStr(MuvMul.Kc,5,TRUE,marc,OK);IF OK THEN Str.Concat(R,R,marc) END;
      Str.Concat(R,R,';');
  END;
  IF (MuvMul.Dty IN MuvMul.Mode) THEN ModeNotEmpti:=TRUE;
      Str.Concat(R,R,ba);
      Str.RealToStr(MuvMul.Kd,5,TRUE,marc,OK);IF OK THEN Str.Concat(R,R,marc) END;
      Str.Concat(R,R,';');
  END;
  IF ModeNotEmpti THEN
     graphics.setcolor(11);
     graphics.settextstyle(2,0,4);
     graphics.outtextxy(80,POSwGeneral,R);
     POSwGeneral:=POSwGeneral+10;
  END
END WrABCD;

PROCEDURE WrABCDco(Fu:Kern.F);
TYPE abType = ARRAY [0..5] OF CHAR;
CONST a  = abType(' ',' ',' ',' ','a','=');
      b  = abType(' ',' ',' ',' ','b','=');
VAR  ab,ba  : abType;
    R    : ARRAY[0..100] OF CHAR;
    D    : LONGREAL;
    marc : ARRAY [0..11] OF CHAR;
    OK,ModeNotEmpti   : BOOLEAN;
BEGIN
 IF Fu.Co THEN
  IF (MuvMul.XYty IN Fu.Mode) THEN ab:=b; ba:=a
                            ELSE ab:=a; ba:=b
  END;
  Str.Concat(R,'  ','   ');ModeNotEmpti:=FALSE;
  IF (MuvMul.Aty IN Fu.Mode) THEN ModeNotEmpti:=TRUE;
      Str.Concat(R,R,ab);
      Str.RealToStr(Fu.Ka,5,TRUE,marc,OK);IF OK THEN Str.Concat(R,R,marc) END;
      Str.Concat(R,R,';');
  END;
  IF (MuvMul.Bty IN Fu.Mode) THEN ModeNotEmpti:=TRUE;
      Str.Concat(R,R,ba);
      Str.RealToStr(Fu.Kb,5,TRUE,marc,OK);IF OK THEN Str.Concat(R,R,marc) END;
      Str.Concat(R,R,';');
  END;
  IF (MuvMul.Cty IN Fu.Mode) THEN ModeNotEmpti:=TRUE;
      Str.Concat(R,R,ab);
      Str.RealToStr(Fu.Kc,5,TRUE,marc,OK);IF OK THEN Str.Concat(R,R,marc) END;
      Str.Concat(R,R,';');
  END;
  IF (MuvMul.Dty IN Fu.Mode) THEN ModeNotEmpti:=TRUE;
      Str.Concat(R,R,ba);
      Str.RealToStr(Fu.Kd,5,TRUE,marc,OK);IF OK THEN Str.Concat(R,R,marc) END;
      Str.Concat(R,R,';');
  END;
  IF ModeNotEmpti THEN
     graphics.outtextxy(80,POSwGeneral,R);
     TextView.POSwGeneral:=TextView.POSwGeneral+10;
  END
 END
END WrABCDco;

PROCEDURE Clear(W : WindowS.WinType;Color:INTEGER);
BEGIN  graphics.setfillstyle(graphics.SOLID_FILL,Color);
       graphics.bar(W^.XA*8,W^.YA*14,W^.XB*8+8,W^.YB*14+14);
       POSwGeneral:=W^.YA*14;
END Clear;

PROCEDURE PutOnTop(W : WindowS.WinType;Color:INTEGER);
VAR   N5,W5,S5,E5:INTEGER;
BEGIN  N5:=W^.YA; S5:=W^.YB;  W5:=W^.XA;   E5:=W^.XB;
       graphics.setfillstyle(graphics.SOLID_FILL,Color);
       graphics.bar(W5*8-8,N5*14-14,E5*8+15,S5*14+27);
       POSwGeneral:=N5*14;
       WindowS.PutOnTop(W);
END PutOnTop;

PROCEDURE Sov;
 BEGIN
 WindowS.PutOnTop(WinSov);
 WindowS.GotoXY(0,2);
   IO.WrStr('         ࠡ⠫  樮'); IO.WrLn;
   IO.WrStr('              ᨥ ணࠬ:'); IO.WrLn;
   IO.WrStr('                    * * *'); IO.WrLn;
   graphics.setfillstyle(graphics.SOLID_FILL,1);
   graphics.bar(17*8,7*14-1,63*8,8*14);
   WindowS.TextColor(WindowS.White);
   IO.WrStr("        S I M P L E F O R M U L A  v1.5");IO.WrLn;
   WindowS.TextColor(WindowS.LightGray);
   IO.WrStr('                    * * *'); IO.WrLn;
   IO.WrStr('  ଠ 䠩  ᮢ⨬  ୮'); IO.WrLn;
   IO.WrStr('      ணࠬ   GRAPHER (Golden Software)'); IO.WrLn;
   IO.WrStr('    -     뢮 १⮢.'); IO.WrLn;
   WindowS.TextColor(WindowS.White);
   IO.WrStr('  ணࠬ  饭 '); IO.WrLn;
   IO.WrStr('    -       ᢮  ᯮ짮.'); IO.WrLn;
   WindowS.TextColor(WindowS.LightGray);
   IO.WrStr('    樮  ਠ'); IO.WrLn;
   IO.WrStr('      ணࠬ ࠭祭:'); IO.WrLn;
   IO.WrStr('    - ⢮   ᯥਬ⠫   祪'); IO.WrLn;
   IO.WrStr('           ॢ  12  .'); IO.WrLn;
   WindowS.TextColor(WindowS.White);
   IO.WrStr('  ᫨   ணࠬ   ਭ      '); IO.WrLn;
   IO.WrStr('         㯨  ᭮  ,'); IO.WrLn;
   IO.WrStr('      .');
END Sov;

PROCEDURE Init;
BEGIN
 WrX:=Wr;
 WinFuDelt:= WindowS.Open(
      WindowS.WinDef(1,16,78,24,               WindowS.LightCyan, WindowS.White,
      FALSE,TRUE,TRUE,TRUE,WindowS.SingleFrame,WindowS.LightGreen, WindowS.White));
 WindowS.SetTitle( WinFuDelt,
   '㥬 㭪樨' +CHR(196)+CHR(196)+CHR(196)
   +CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)
   +CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)
   +CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
   '..'+CHR(196)+CHR(196)+'.⪫.',WindowS.RightUpperTitle);

 WinSov:= WindowS.Open(
      WindowS.WinDef(16,2,63,22,WindowS.LightGray, WindowS.White,
      FALSE,TRUE,FALSE,TRUE,WindowS.SingleFrame,WindowS.LightGray,WindowS.White));
 WindowS.SetTitle( WinSov,'.룠 ⥫. 362-78-77',WindowS.RightLowerTitle);
END Init;
END TextView.
